--- lang-sla.tex.1	2010-05-18 17:51:50.000000000 +0200
+++ lang-sla.tex	2010-07-10 13:50:08.711290429 +0200
@@ -117,9 +117,9 @@
    \c!rightsentence=---,
    \c!leftsubsentence=---,
    \c!rightsubsentence=---,
-   \c!leftquote=\upperleftsinglesixquote,
+   \c!leftquote=\lowerleftsingleninequote,
    \c!rightquote=\upperrightsingleninequote,
-   \c!leftquotation=\upperleftdoublesixquote,
+   \c!leftquotation=\lowerleftdoubleninequote,
    \c!rightquotation=\upperrightdoubleninequote,
    \c!date={\v!day,\ ,\v!month,\ ,\v!year},
    \s!mapping=ec,
@@ -213,7 +213,7 @@
 \setupheadtext [\s!pl] [\v!intermezzi=Intermezza]
 \setupheadtext [\s!cs] [\v!intermezzi=Intermezza]
 \setupheadtext [\s!sk] [\v!intermezzi=Intermezz\aacute]
-\setupheadtext [\s!hr] [\v!intermezzi=Intermezza]
+\setupheadtext [\s!hr] [\v!intermezzi=Intermeci]
 \setupheadtext [\s!sl] [\v!intermezzi=Intermezzi]
 
 \setupheadtext [\s!pl] [\v!index=Indeks]
@@ -243,13 +243,13 @@
 %setupheadtext [\s!pl] [pubs=?]
 \setupheadtext [\s!cs] [pubs=Literatura]
 %setupheadtext [\s!sk] [pubs=?]
-%setupheadtext [\s!hr] [pubs=?]
+\setupheadtext [\s!hr] [pubs=Literatura]
 \setupheadtext [\s!sl] [pubs=Literatura]
 
 \setuplabeltext [\s!pl] [\v!table=Tabela ]
 \setuplabeltext [\s!cs] [\v!table=Tabulka ]
 \setuplabeltext [\s!sk] [\v!table=Tabu\lcaron ka ]
-\setuplabeltext [\s!hr] [\v!table=T\aacute bl\aacute zat ] % [\v!table=Tablica ]
+\setuplabeltext [\s!hr] [\v!table=Tablica ]
 \setuplabeltext [\s!sl] [\v!table=Tabela ]
 
 \setuplabeltext [\s!pl] [\v!figure=Ilustracja ]
@@ -261,7 +261,7 @@
 \setuplabeltext [\s!pl] [\v!intermezzo=Intermezzo ]
 \setuplabeltext [\s!cs] [\v!intermezzo=Intermezzo ]
 \setuplabeltext [\s!sk] [\v!intermezzo=Intermezzo ]
-\setuplabeltext [\s!hr] [\v!intermezzo=Intermezzo ]
+\setuplabeltext [\s!hr] [\v!intermezzo=Intermeco ]
 \setuplabeltext [\s!sl] [\v!intermezzo=Intermezzo ]
 
 \setuplabeltext [\s!pl] [\v!graphic=Grafika ]
@@ -273,31 +273,31 @@
 \setuplabeltext [\s!pl] [\v!chapter=] % Rozdzia\l
 \setuplabeltext [\s!cs] [\v!chapter=] % Kapitola
 \setuplabeltext [\s!sk] [\v!chapter=] % Kapitola
-\setuplabeltext [\s!hr] [\v!chapter=] % Rozdzia\l
+\setuplabeltext [\s!hr] [\v!chapter=] % Poglavlje
 \setuplabeltext [\s!sl] [\v!chapter=] % Poglavje
 
 \setuplabeltext [\s!pl] [\v!section=] % Podrozdzia\l
 \setuplabeltext [\s!cs] [\v!section=] % Sekce
 \setuplabeltext [\s!sk] [\v!section=] % Sekcia
-\setuplabeltext [\s!hr] [\v!section=] % Podrozdzia\l
-\setuplabeltext [\s!sl] [\v!section=]
+\setuplabeltext [\s!hr] [\v!section=] % Odjeljak
+\setuplabeltext [\s!sl] [\v!section=] % Sekcija
 
 \setuplabeltext [\s!pl] [\v!subsection=]
 \setuplabeltext [\s!cs] [\v!subsection=] % Podsekce
 \setuplabeltext [\s!sk] [\v!subsection=] % Podsekcia
-\setuplabeltext [\s!hr] [\v!subsection=]
+\setuplabeltext [\s!hr] [\v!subsection=] % Pododjeljak
 \setuplabeltext [\s!sl] [\v!subsection=]
 
 \setuplabeltext [\s!pl] [\v!subsubsection=]
 \setuplabeltext [\s!cs] [\v!subsubsection=] % Podpodsekce
 \setuplabeltext [\s!sk] [\v!subsubsection=] % Podpodsekcia
-\setuplabeltext [\s!hr] [\v!subsubsection=]
+\setuplabeltext [\s!hr] [\v!subsubsection=] % Podpododjeljak
 \setuplabeltext [\s!sl] [\v!subsubsection=]
 
 \setuplabeltext [\s!pl] [\v!subsubsubsection=]
 \setuplabeltext [\s!cs] [\v!subsubsubsection=] % Podpodpodsekce
 \setuplabeltext [\s!sk] [\v!subsubsubsection=] % Podpodpodsekcia
-\setuplabeltext [\s!hr] [\v!subsubsubsection=]
+\setuplabeltext [\s!hr] [\v!subsubsubsection=] % Podpodpododjeljak
 \setuplabeltext [\s!sl] [\v!subsubsubsection=]
 
 \setuplabeltext [\s!pl] [\v!appendix=] % Dodatek
@@ -315,13 +315,13 @@
 \setuplabeltext [\s!pl] [\v!line=wiersz ]
 \setuplabeltext [\s!cs] [\v!line=\rcaron\aacute dek ]
 \setuplabeltext [\s!sk] [\v!line=riadok ]
-\setuplabeltext [\s!hr] [\v!line=red ]
+\setuplabeltext [\s!hr] [\v!line=redak ]
 \setuplabeltext [\s!sl] [\v!line=vrstica ]
 
 \setuplabeltext [\s!pl] [\v!lines=wiersze ]
 \setuplabeltext [\s!cs] [\v!lines=\rcaron\aacute dky ]
 \setuplabeltext [\s!sk] [\v!lines=riadky ]
-\setuplabeltext [\s!hr] [\v!lines=redovi ]
+\setuplabeltext [\s!hr] [\v!lines=retci ]
 \setuplabeltext [\s!sl] [\v!lines=vrstice ]
 
 \setuplabeltext [\s!pl]   [\v!january=stycznia]